function ComixPlus_OnLoad()

	ComixPlus_Frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	ComixPlus_Frame:RegisterEvent("UNIT_SPELLCAST_SENT")
	ComixPlus_Frame:RegisterEvent("PLAYER_TARGET_CHANGED")

	spellcastevents = {}
	targetevents = {}
	customevents = {}

	currentselectedid = 0
	selectedtableindex = 0
	currenttab = 1
	
	
	comixplusimagepath = "Interface\\Addons\\ComixPlus\\Images\\"
	comixplussoundpath = "Interface\\Addons\\ComixPlus\\Sounds\\"
	
	PanelTemplates_SetNumTabs(ComixPlus_Frame, 3);  -- 3 because there are 3 frames total.
	PanelTemplates_SetTab(ComixPlus_Frame, 1);      -- 1 because we want tab 1 selected.
	ComixPlus_ChangeEvent(1)
	ComixPlus_SetupMenuItems()
	Comix_ActivatePlus()
	
  -- Slash Commands --
  SlashCmdList["ComixPlus"] = ComixPlus_Command;
	SLASH_ComixPlus1 = "/ComixPlus";
	SLASH_ComixPlus2 = "/comixplus";
end

function ComixPlus_FrameHide()

	ComixPlus_ClearForm()
end

local r,g,b,a = 1, 1, 1, nil;

local function myColorCallback(restore)
 local newR, newG, newB, newA;
 if restore then
  -- The user bailed, we extract the old color from the table created by ShowColorPicker.
  newR, newG, newB, newA = unpack(restore);
 else
  -- Something changed
  newA, newR, newG, newB = OpacitySliderFrame:GetValue(), ColorPickerFrame:GetColorRGB();
 end
 
 -- Update our internal storage.
 r, g, b, a = newR, newG, newB, newA;
	--ComixPlus_FrameButtonTest:SetHighlightTextColor(r, g, b)
	ComixPlus_FrameButtonColor:GetNormalTexture():SetVertexColor(r, g, b);
 -- And update any UI elements that use this color...
end

function ShowColorPicker(r, g, b, a, changedCallback)
 ColorPickerFrame:SetColorRGB(r,g,b);
 ColorPickerFrame.hasOpacity, ColorPickerFrame.opacity = (a ~= nil), a;
 ColorPickerFrame.previousValues = {r,g,b,a};
 ColorPickerFrame.func, ColorPickerFrame.opacityFunc, ColorPickerFrame.cancelFunc = 
  changedCallback, changedCallback, changedCallback;
 ColorPickerFrame:Hide(); -- Need to run the OnShow handler.
 ColorPickerFrame:Show();
end


function ComixPlus_Color()
	ShowColorPicker(r, g, b, a, myColorCallback);
end


function ComixPlus_OnEvent(self, event, ...)
	local logEvent = select(2, ...)
	local sourceFlags = select(6, ...)
	local destFlags = select(10, ...)

	if event == "COMBAT_LOG_EVENT_UNFILTERED" then
		if bit.band(sourceFlags, COMBATLOG_OBJECT_AFFILIATION_MINE) > 0 or bit.band(destFlags, COMBATLOG_OBJECT_AFFILIATION_MINE) > 0 then
			--DEFAULT_CHAT_FRAME:AddMessage("DING DING "..arg2)
		--if arg7 == UnitName("player") then
			for i=1, #(customevents) do
				if logEvent == customevents[i][2] then
					local test = select(customevents[i][3], ...)
					--DEFAULT_CHAT_FRAME:AddMessage("DING DING "..arg2.." "..tostring(test))
					local bingbong = false
					--DEFAULT_CHAT_FRAME:AddMessage(type(customevents[i][4]).. " " .. customevents[i][5]);
					if type(customevents[i][4]) == "number" and customevents[i][5] ~= 2 then
						
						if customevents[i][5] == 1 then
							if test <= customevents[i][4] then
								--DEFAULT_CHAT_FRAME:AddMessage("bing bong L- "..customevents[i][4])
								bingbong = true
							end
						else -- its 3
							if test >= customevents[i][4] then
								--DEFAULT_CHAT_FRAME:AddMessage("bing bong G- "..customevents[i][4])
								bingbong = true
							end
						end
					
					else

						if test == customevents[i][4] then
							--DEFAULT_CHAT_FRAME:AddMessage("bing bong - "..customevents[i][4])
							bingbong = true
						end
					end
					
					
					if bingbong then
						if customevents[i][6] == true then -- we need to play a sound
							Comix_CustomSound(comixplussoundpath..customevents[i][7])
						end
						
						if customevents[i][8] == true then -- we need to show an image
							Comix_CustomPic(comixplusimagepath..customevents[i][9])
						end
						
						if customevents[i][10] == true then -- we need to shake
							Comix_ShakeScreen()
						end
						
						if customevents[i][11] == true then -- we need to flash the screen
							Comix_ScreenFlash(customevents[i][12], customevents[i][13], customevents[i][14], customevents[i][15])
						end
						
					end
					
				end
			end
		--end
		end
	end
	
	if event == "UNIT_SPELLCAST_SENT" then
		for i=1, #spellcastevents do
			if logEvent == spellcastevents[i][2] then
				--DEFAULT_CHAT_FRAME:AddMessage("bing bong sc - "..spellcastevents[i][2])
				if spellcastevents[i][3] == true then -- we need to play a sound
					Comix_CustomSound(comixplussoundpath..spellcastevents[i][4]) -- this is the sound to play
				end
				
				if spellcastevents[i][5] == true then -- we need to show an image
					Comix_CustomPic(comixplusimagepath..spellcastevents[i][6]) -- this is the pic to show
				end
				
				if spellcastevents[i][7] == true then -- we need to shake the screen
					Comix_ShakeScreen()
				end
				
				if spellcastevents[i][8] == true then -- we need to flash
					Comix_ScreenFlash(spellcastevents[i][9], spellcastevents[i][10], spellcastevents[i][11], spellcastevents[i][12]) -- flash with color and size
				end
				
				
			end
		end
	end
	
	if event == "PLAYER_TARGET_CHANGED" then
		if UnitName("target" ) ~= nil then
			for i=1, #targetevents do
				if UnitName("target") == targetevents[i][2] then
				--	DEFAULT_CHAT_FRAME:AddMessage("bing bong tar - "..targetevents[i][2])
					
				if targetevents[i][3] == true then -- we need to play a sound
					Comix_CustomSound(comixplussoundpath..targetevents[i][4]) -- this is the sound to play
				end
				
				if targetevents[i][5] == true then -- we need to show an image
					Comix_CustomPic(comixplusimagepath..targetevents[i][6]) -- this is the pic to show
				end
				
				if targetevents[i][7] == true then -- we need to shake the screen
					Comix_ShakeScreen()
				end
				
				if targetevents[i][8] == true then -- we need to flash
					Comix_ScreenFlash(targetevents[i][9], targetevents[i][10], targetevents[i][11], targetevents[i][12]) -- flash with color and size
				end
					
				end
			end
		end
	end

end

function ComixPlus_Command(nerd)

	nerd = strlower(nerd)
	
	if nerd == "test1" then
		Comix_CustomPic("Interface\\Addons\\ComixPlus\\Images\\blade12.blp")
	else if nerd == "test2" then
		Comix_CustomSound("Interface\\Addons\\ComixPlus\\Sounds\\bucketonothing.mp3")
	else if nerd == "test3" then
		Comix_ScreenFlash(r, g, b, 1);
	else
	--DEFAULT_CHAT_FRAME:AddMessage("test - "..#(customevents))
	ComixPlus_Frame:Show()
	end
	end
	end
	--Comix_DongSound(ComixSpecialSounds,15)
	--DEFAULT_CHAT_FRAME:AddMessage("here2")


end

function ComixPlus_CreateNewEvent()
	
	
	local event = {}
	
	if currenttab == 3 then
	
		event[1] = "New Event" -- name
		event[2] = "" -- event
		event[3] = 1 -- argument
		event[4] = "" -- search value
		event[5] = 2 -- greater/less than
		event[6] = false --play sound?
		event[7] = "" --filename of sound
		event[8] = false -- show image?
		event[9] = "" --filename of image
		event[10] = false -- shake
		event[11] = false -- flash
		event[12] = 1 -- R value
		event[13] = 1 -- G value
		event[14] = 1 -- B value
		event[15] = 1 -- flash size
	else
		event[1] = "New Event" --name
		event[2] = "" -- search value
		event[3] = false --play sound?
		event[4] = "" --filename of sound
		event[5] = false -- show image?
		event[6] = "" --filename of image
		event[7] = false -- shake
		event[8] = false -- flash
		event[9] = 1 -- R value
		event[10] = 1 -- G value
		event[11] = 1 -- B value
		event[12] = 1 -- flash size
	
	end
	
	tinsert(GetCurrentTable(), event)
	ComixPlusScrollBar_Update()
	
end

function ComixPlus_ShowEvent(index)
	
	nameedit:SetText(GetCurrentTable()[index][1])
	
	if currenttab == 3 then
		eventedit:SetText(GetCurrentTable()[index][2])
		argedit:SetText(GetCurrentTable()[index][3])
		searchvaledit:SetText(GetCurrentTable()[index][4])
		comixplus_greaterlessthan_slider:SetValue(GetCurrentTable()[index][5])
		comix_plus_check_sound:SetChecked(GetCurrentTable()[index][6])
		soundedit:SetText(GetCurrentTable()[index][7])
		comix_plus_check_image:SetChecked(GetCurrentTable()[index][8])
		imageedit:SetText(GetCurrentTable()[index][9])
		comix_plus_check_shake:SetChecked(GetCurrentTable()[index][10])
		comix_plus_check_flash:SetChecked(GetCurrentTable()[index][11])
		if GetCurrentTable()[index][15] == 1 then
			comix_plus_check_flashsize:SetChecked(true)
		else
			comix_plus_check_flashsize:SetChecked(false)
		end
		
	r, g, b = GetCurrentTable()[index][12], GetCurrentTable()[index][13], GetCurrentTable()[index][14];
	
	ComixPlus_FrameButtonColor:GetNormalTexture():SetVertexColor(r, g, b);
		
		
	else

		searchvaledit:SetText(GetCurrentTable()[index][2])
		
		comix_plus_check_sound:SetChecked(GetCurrentTable()[index][3])
		soundedit:SetText(GetCurrentTable()[index][4])
		comix_plus_check_image:SetChecked(GetCurrentTable()[index][5])
		imageedit:SetText(GetCurrentTable()[index][6])
		comix_plus_check_shake:SetChecked(GetCurrentTable()[index][7])
		comix_plus_check_flash:SetChecked(GetCurrentTable()[index][8])
		if GetCurrentTable()[index][12] == 1 then
			comix_plus_check_flashsize:SetChecked(true)
		else
			comix_plus_check_flashsize:SetChecked(false)
		end
		
	r, g, b = GetCurrentTable()[index][9], GetCurrentTable()[index][10], GetCurrentTable()[index][11];
	
	ComixPlus_FrameButtonColor:GetNormalTexture():SetVertexColor(r, g, b);
	end


end

function ComixPlus_ValidateForm()
	
	valid = true
	
	if nameedit:GetText() == "" then
		valid = false
		DEFAULT_CHAT_FRAME:AddMessage("Name Cannot be empty")
	end
	
	if strfind(nameedit:GetText(), "%w") == nil then
		valid = false
		DEFAULT_CHAT_FRAME:AddMessage("Name must contain at least one alphanumeric character")
	end
	
	if currenttab == 3 then
		if tonumber(argedit:GetText()) == nil then
			valid = false
			DEFAULT_CHAT_FRAME:AddMessage("Arg field must contain a number")
		else
			if tonumber(argedit:GetText()) < 1 then
				valid = false
				DEFAULT_CHAT_FRAME:AddMessage("Arg field value must be greater than 0")
			end
		end
		
		if eventedit:GetText() == "" then
			DEFAULT_CHAT_FRAME:AddMessage("Event field is empty, the event will be useless without one")
		end		
		
	end
	
	
	if searchvaledit:GetText() == "" then
		DEFAULT_CHAT_FRAME:AddMessage("Search value field is empty, the event will be useless without one")
	end
	
	if int2bool(comix_plus_check_sound:GetChecked()) then
		if soundedit:GetText() == "" then
			DEFAULT_CHAT_FRAME:AddMessage("Sound field is empty, this should not cause an error but it will still try to play nothing")
		end
	end
	
	if int2bool(comix_plus_check_image:GetChecked()) then
		if imageedit:GetText() == "" then
			DEFAULT_CHAT_FRAME:AddMessage("Image field is empty, this should not cause an error but it will still try to show nothing")
		end
	end
	
	
	return valid
end

function ComixPlus_UpdateEvent()
	if selectedtableindex == 0 then
		DEFAULT_CHAT_FRAME:AddMessage("No event selected")
		return
	end
	if ComixPlus_ValidateForm() == false then
		DEFAULT_CHAT_FRAME:AddMessage("Form validation failed, no data updated")
		return
	end
	GetCurrentTable()[selectedtableindex][1] = nameedit:GetText()
	
	if currenttab == 3 then
		GetCurrentTable()[selectedtableindex][2] = eventedit:GetText()
		GetCurrentTable()[selectedtableindex][3] = tonumber(argedit:GetText())
		if tonumber(searchvaledit:GetText()) then
			GetCurrentTable()[selectedtableindex][4] = tonumber(searchvaledit:GetText())
		else
			GetCurrentTable()[selectedtableindex][4] = searchvaledit:GetText()
		end
		GetCurrentTable()[selectedtableindex][5] = comixplus_greaterlessthan_slider:GetValue()
		GetCurrentTable()[selectedtableindex][6] = int2bool(comix_plus_check_sound:GetChecked())
		GetCurrentTable()[selectedtableindex][7] = soundedit:GetText()
		GetCurrentTable()[selectedtableindex][8] = int2bool(comix_plus_check_image:GetChecked())
		GetCurrentTable()[selectedtableindex][9] = imageedit:GetText()
		GetCurrentTable()[selectedtableindex][10] = int2bool(comix_plus_check_shake:GetChecked())
		GetCurrentTable()[selectedtableindex][11] = int2bool(comix_plus_check_flash:GetChecked())
		GetCurrentTable()[selectedtableindex][12] = r
		GetCurrentTable()[selectedtableindex][13] = g
		GetCurrentTable()[selectedtableindex][14] = b
		if int2bool(comix_plus_check_flashsize:GetChecked()) then
			GetCurrentTable()[selectedtableindex][15] = 1
		else
			GetCurrentTable()[selectedtableindex][15] = 2
		end
	
	else
	
		GetCurrentTable()[selectedtableindex][2] = searchvaledit:GetText()
		GetCurrentTable()[selectedtableindex][3] = int2bool(comix_plus_check_sound:GetChecked())
		GetCurrentTable()[selectedtableindex][4] = soundedit:GetText()
		GetCurrentTable()[selectedtableindex][5] = int2bool(comix_plus_check_image:GetChecked())
		GetCurrentTable()[selectedtableindex][6] = imageedit:GetText()
		GetCurrentTable()[selectedtableindex][7] = int2bool(comix_plus_check_shake:GetChecked())
		GetCurrentTable()[selectedtableindex][8] = int2bool(comix_plus_check_flash:GetChecked())
		GetCurrentTable()[selectedtableindex][9] = r
		GetCurrentTable()[selectedtableindex][10] = g
		GetCurrentTable()[selectedtableindex][11] = b
		if int2bool(comix_plus_check_flashsize:GetChecked()) then
			GetCurrentTable()[selectedtableindex][12] = 1
		else
			GetCurrentTable()[selectedtableindex][12] = 2
		end
	end

	DEFAULT_CHAT_FRAME:AddMessage("Event Updated Successfully")
	ComixPlusScrollBar_Update()

end

function ComixPlus_DeleteSelectedEvent()
	
	if selectedtableindex == 0 then
		DEFAULT_CHAT_FRAME:AddMessage("No event selected")
		return
	end
	
	tremove(GetCurrentTable(), selectedtableindex)
	ComixPlus_ClearForm()
	ComixPlusScrollBar_Update()
	
end


function ComixPlus_ClearForm()

	nameedit:SetText("")
	nameedit:ClearFocus()
	argedit:SetText("")
	argedit:ClearFocus()
	eventedit:SetText("")
	eventedit:ClearFocus()
	searchvaledit:SetText("")
	searchvaledit:ClearFocus()
	soundedit:SetText("")
	soundedit:ClearFocus()
	imageedit:SetText("")
	imageedit:ClearFocus()
	
	comixplus_greaterlessthan_slider:SetValue(2)
	
	comix_plus_check_sound:SetChecked(false)
	comix_plus_check_image:SetChecked(false)
	comix_plus_check_shake:SetChecked(false)
	comix_plus_check_flash:SetChecked(false)
	comix_plus_check_flashsize:SetChecked(true)
	
	 r, g, b, a = 1, 1, 1, 1;
	
	ComixPlus_FrameButtonColor:GetNormalTexture():SetVertexColor(r, g, b);
	ComixPlus_ListClick(0)
	ComixPlusScrollBar_Update()
	

end

function ComixPlus_ListClick(id)
	if id == 0 then
		if currentselectedid ~= 0 then
		for i = 1, 15 do
			getglobal("ComixPlusEntry"..i):SetNormalFontObject("GameFontHighlightLeft");
		end
		end
		currentselectedid = 0
		selectedtableindex = 0
		return
	end
		
		if currentselectedid ~= 0 then
		for i = 1, 15 do
			getglobal("ComixPlusEntry"..i):SetNormalFontObject("GameFontHighlightLeft");
		end
		end
		getglobal("ComixPlusEntry"..id):SetNormalFontObject("GameFontGreen");
		
		currentselectedid = id
		selectedtableindex = id + FauxScrollFrame_GetOffset(ComixPlusScrollBar)
		ComixPlus_ShowEvent(selectedtableindex)
	--DEFAULT_CHAT_FRAME:AddMessage("ListClick called - "..id)
	--DEFAULT_CHAT_FRAME:AddMessage("button says - "..GetCurrentTable()[id + FauxScrollFrame_GetOffset(ComixPlusScrollBar)][1])
	
end

function ComixPlus_ChangeEvent(id)
	ComixPlus_ClearForm()
	ComixPlus_ListClick(0)
	PanelTemplates_SetTab(ComixPlus_Frame, id);
	currenttab = id
	if id ~= 3 then
		argedit:Hide()
		eventedit:Hide()
		comixplus_greaterlessthan_slider:Hide()
	else
		argedit:Show()
		eventedit:Show()
		comixplus_greaterlessthan_slider:Show()
	end
	--DEFAULT_CHAT_FRAME:AddMessage("changeevent - "..id)
	--DEFAULT_CHAT_FRAME:AddMessage("items - "..#GetCurrentTable())
	--if GetCurrentTable()[1] then
	--	DEFAULT_CHAT_FRAME:AddMessage("items1 - "..#GetCurrentTable()[1])
	--end
	ComixPlusScrollBar_Update()

end

 function ComixPlusScrollBar_Update()
   if GetCurrentTable() == nil then
    return;
   end
   
   local line; -- 1 through 5 of our window to scroll
   local lineplusoffset; -- an index into our data calculated from the scroll offset
   FauxScrollFrame_Update(ComixPlusScrollBar,#GetCurrentTable(),15,16);
  -- DEFAULT_CHAT_FRAME:AddMessage("We're at "..FauxScrollFrame_GetOffset(ComixPlusScrollBar))
   for line=1,15 do
     lineplusoffset = line + FauxScrollFrame_GetOffset(ComixPlusScrollBar);
     if lineplusoffset < #GetCurrentTable() + 1 then--50 then
       getglobal("ComixPlusEntry"..line):SetText(GetCurrentTable()[lineplusoffset][1]);
	   if lineplusoffset == selectedtableindex then
			getglobal("ComixPlusEntry"..line):SetNormalFontObject("GameFontGreen");
		else
			getglobal("ComixPlusEntry"..line):SetNormalFontObject("GameFontHighlight");
	   end
       getglobal("ComixPlusEntry"..line):Show();
     else
       getglobal("ComixPlusEntry"..line):Hide();
     end
   end
   

 end
 
 
 function GetCurrentTable()
 
	if currenttab == 1 then
		return spellcastevents
	else if currenttab == 2 then
		return targetevents
	else if currenttab == 3 then
		return customevents
	else
		return nil
	end
	end
	end
 
 
 end

 function GetNumTableItems()
 
	if currenttab == 1 then
	
	else if currenttab == 2 then
		
	else if currenttab == 3 then
	
	else
		return nil
	end
	end
	end
	
 end
 
 function ComixPlus_SliderHandler(val)
	
	if val == 1 then
		comixplus_greaterlessthan_sliderText:SetText("<=")
	else if val == 2 then
		comixplus_greaterlessthan_sliderText:SetText("=")
	else
		comixplus_greaterlessthan_sliderText:SetText(">=")
	end
	end
 end
 
 function ComixPlus_SetupMenuItems()
	
	imageedit.ttext="enter the filename of the image file in the ComixPlus/Images folder"
	soundedit.ttext="enter the filename of the sound file in the ComixPlus/Sounds folder"
	searchvaledit.ttext="enter the value to search for"
	eventedit.ttext="enter the event to search for, see\nhttp://www.wowwiki.com/API_COMBAT_LOG_EVENT#Events \nfor more info"
	nameedit.ttext="enter the name for this"
	argedit.ttext="enter the argument number for this to check against\nhttp://www.wowwiki.com/API_COMBAT_LOG_EVENT#Events \nfor more info"
	
	comixplus_greaterlessthan_slider.ttext="Change how the search value is compared, <=, = or >=, has no effect on non numeric search values"
	comixplus_greaterlessthan_sliderLow:SetText("Less")
	comixplus_greaterlessthan_sliderHigh:SetText("Greater")
	
	comix_plus_check_sound.ttext="Enable sound for this"
 	comix_plus_check_soundText:SetText("Sound");	
	comix_plus_check_image.ttext="Enable image for this"
 	comix_plus_check_imageText:SetText("Image");	
	comix_plus_check_shake.ttext="Enable screen shakes for this"
 	comix_plus_check_shakeText:SetText("Shake");	
	comix_plus_check_flash.ttext="Enable screen flash for this"
 	comix_plus_check_flashText:SetText("Flash");
	comix_plus_check_flashsize.ttext="Checking this will use the larger flash texture"
 	comix_plus_check_flashsizeText:SetText("Large Flash");
	ComixPlus_FrameTab1.ttext="When you attempt to cast a spell, this event will fire"
	ComixPlus_FrameTab2.ttext="When you change targets, this event will fire"
	ComixPlus_FrameTab3.ttext="This event will fire on any combat\nlog action, it is limited to player actions only\n\nNOTE: this is an advanced mode and\nrequires knowledge of the \nCOMBAT_LOG_EVENT_UNFILTERED event, please see\nhttp://www.wowwiki.com/API_COMBAT_LOG_EVENT \nfor more information"
	ComixPlus_FrameButtonColor.ttext="Click here to change the flash color"
	ComixPlus_FrameButtonClose.ttext="Close the window"
	ComixPlus_FrameButtonNew.ttext="Create a new event"
	ComixPlus_FrameButtonUpdate.ttext="Update the currently selected event with the current form data"
	ComixPlus_FrameButtonRemove.ttext="Delete the currently selected event, THIS ACTION CANNOT BE UNDONE"
 end
